unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DList;

const
  StrStruct = 1;
    
type
  PS = ^string;

  TMainForm = class(TForm)
    Edit1: TEdit;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    ListBox2: TListBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    DList1: TDList;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure DList1DisposeStructure(Sender: TObject; Structure: Integer;
      Properties: Pointer);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DList1Filter(Sender: TObject; Str: String;
      Structure: Integer; Properties: Pointer; var Enabled: Boolean);
    procedure DList1LoadStructure(Sender: TObject; Structure: Integer;
      var Properties: Pointer; H, Format: Integer);
    procedure DList1SaveStructure(Sender: TObject; Structure: Integer;
      Properties: Pointer; H, Format: Integer);
    procedure DList1FileHeader(Sender: TObject; H: Integer;
      Action: THeaderAction; Format, InitPos: Integer);
  private
    { Private declarations }
    ListMode: (lm0, lm1, lm2);
    procedure ShowDescription;
    procedure Refresh;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.Button1Click(Sender: TObject);
var
  Description: PS;
begin
  if Edit1.Text<>'' then with DList1 do begin
    New(Description);
    Description^:=Edit5.Text;
    Add(Edit1.Text, StrStruct, Description);
    Refresh;
  end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  DList1.SetFilter(Edit2.Text,StrToInt(Edit3.Text),StrToInt(Edit4.Text));
  DList1.Clear;
  Refresh;
end;

procedure TMainForm.ShowDescription;
var
  S: pointer;
  Structure: integer;
begin
  Label8.Caption:='';
  with DList1 do if ListBox2.Focused then with ListBox2 do begin
    if (Items.Count=0) or (ItemIndex<0) then Exit;
    GetFields(Items[ItemIndex], Structure, S);
  end
  else with ListBox1 do begin
    if (Items.Count=0) or (ItemIndex<0) then Exit;
    GetFields(Items[ItemIndex], Structure, S);
  end;
  Label8.Caption:=PS(S)^;
end;

procedure TMainForm.Refresh;
begin
  with DList1 do begin
    ListBox1.Clear;
    SetFilter('',0,100);
    ListMode:=lm1;
    GetList;
    ListBox2.Clear;
    SetFilter(Edit2.Text,StrToInt(Edit3.Text),StrToInt(Edit4.Text));
    ListMode:=lm2;
    GetList;
  end;
  ShowDescription;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  Refresh;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  i:integer;
begin
  with ListBox1 do if ItemIndex>-1 then begin
    DList1.Remove(Items[ItemIndex]);
    i:=ItemIndex;
    MainForm.Refresh;
    if Items.Count-1<i then ItemIndex:=Items.Count-1
    else ItemIndex:=i;
  end;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  DList1.ClearAll;
  Refresh;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
  ListMode:=lm0;
  DList1.SetFilter(Edit2.Text,StrToInt(Edit3.Text),StrToInt(Edit4.Text));
  DList1.Save(ExtractFilePath(ParamStr(0))+'Test.dls',1);
  Button7Click(Sender);
end;

procedure TMainForm.Button7Click(Sender: TObject);
begin
  DList1.ClearAll;
  DList1.Load(ExtractFilePath(ParamStr(0))+'Test.dls',1);
  Refresh;
end;

procedure TMainForm.DList1DisposeStructure(Sender: TObject;
  Structure: Integer; Properties: Pointer);
begin
  if Structure = StrStruct then Dispose(PS(Properties));
end;

procedure TMainForm.ListBox1Click(Sender: TObject);
begin
  ListBox2.ItemIndex:=-1;
  ShowDescription;
end;

procedure TMainForm.ListBox2Click(Sender: TObject);
begin
  ListBox1.ItemIndex:=-1;
  ShowDescription;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Button7Click(Sender);
end;

procedure TMainForm.DList1Filter(Sender: TObject; Str: String;
  Structure: Integer; Properties: Pointer; var Enabled: Boolean);
begin
  case ListMode of
    lm0: begin end;
    lm1: ListBox1.Items.Add(Str);
    lm2: ListBox2.Items.Add(Str);
  end;
end;

procedure TMainForm.DList1LoadStructure(Sender: TObject;
  Structure: Integer; var Properties: Pointer; H, Format: Integer);
begin
  if Structure = StrStruct then begin
    New(PS(Properties));
    ReadString(H, PS(Properties)^);
  end;
end;

procedure TMainForm.DList1SaveStructure(Sender: TObject;
  Structure: Integer; Properties: Pointer; H, Format: Integer);
begin
  if Structure = StrStruct then WriteString(H, PS(Properties)^);
end;

procedure TMainForm.DList1FileHeader(Sender: TObject; H: Integer;
  Action: THeaderAction; Format, InitPos: Integer);
var
  MyAge: integer;
begin
  case Action of
    haRead: begin
      FileRead(H, MyAge, SizeOf(MyAge));
      {Use MyAge}
    end;
    haWrite: begin
      MyAge:=32;
      FileWrite(H, MyAge, SizeOf(MyAge));
    end;
  end;
end;

end.
